/*
 * qiu.form.1.0.js 15-08-12
 * */
;
(function($) {
	$.myform = function(arg) {
			var obj = this;
			/**----reg----**/
			var arrayReg = [];
			arrayReg.push({
				"cid": "empty",
				"reg": /^[A-Za-z0-9]{4,5}$/
			}); //验证码

			arrayReg.push({
				"cid": "phone",
				"reg": /^1[3|4|5|8][0-9]\d{8,8}$/
			}); //手机号
			arrayReg.push({
				"cid": "pw",
				"reg": /^[a-zA-Z|\d]\w{5,17}$/
			}); //密码
			arrayReg.push({
				"cid": "again_pw",
				"inid": '.pw'
			}); //确认密码
			arrayReg.push({
				"cid": "id",
				"reg": /(^\d{15}$)|(^\d{17}([0-9]|X)$)/i
			}); //身份证号
			arrayReg.push({
				"cid": "zip_code",
				"reg": /^([\u4e00-\u9fa5]){2,7}$/

			}); //企业联系人
			arrayReg.push({
				"cid": "chinese",
				"reg": /^((\d{3,4}\-)|)\d{7,8}(|([-\u8f6c]{1}\d{1,5}))$/

			}); //客服电话
			/*--var reg--*/
			if(arg.reg) {
				var ar = arg.reg;
				for(var i = 0; i < ar.length; i++) {
					arrayReg.unshift(ar[i])
				}
			}
			this.arr = arrayReg;
			/**----trigger----**/
			var trigger = arg.trigger ? arg.trigger + ' change' : 'blur change';

			/*---function----*/
			function falsefun(_obj) {
				if(arg.falsefun) arg.falsefun(_obj);
				_obj.addClass('false');
				//阻止默认行为,trigger时不触发
				return false;
			}

			function truefun(_obj) {
				if(arg.truefun) arg.truefun(_obj);
				_obj.removeClass('false');
				return true;
			}
			//用data-定位，jq.inArray()来验证
			function inputfun(_obj, array) {
				var length = array.length;
				for(var i = 0; i < length; i++) {
					var cid = array[i].cid,
						reg = array[i].reg,
						inid = array[i].inid;
					if(_obj.hasClass(cid)) {
						var value = _obj.val();
						if(inid && value != $(inid).val()) {
							falsefun(_obj);
							return false;
						} else if(value == '' || !value.match(reg)) {
							falsefun(_obj)
							return false;
						} else {
							if(_obj.hasClass('false'))
								truefun(_obj);
							return true;
						} //value
					} //1、again.val()，2、reg,3、true
				} //for
			} //$(select).val() function;
			function checkedfun(_obj) {
				var min = _obj.attr('data-min') || '1';
				value = 0;
				_obj.find('input:checked').each(function() {
					value++;
				});
				if(value < min) {
					falsefun(_obj);
					return false;
				} else {
					truefun(_obj);
					return true;
				}
			}
			/**--trigger fun--**/
			$('.myform').on(trigger, function() {

				return inputfun($(this), arrayReg);
			}); //输入框执行
			$('.mycheck input').on('change', function() {

				return checkedfun($(this).parents('.mycheck'));
			}); //选项框执行
			/**--this fun--**/
			this.formSub = function(obj, loop) {
					var returnV = 0;
					var _obj = $(obj).find(".myform");
					for(i in _obj) {

						var bool = (_obj.eq(i).hasClass('mycheck')) ? checkedfun(_obj.eq(i)) : inputfun(_obj.eq(i), arrayReg);
						if(bool) returnV++;
						if(!loop && !bool) return false;
					}
					if(returnV >= _obj.size()) {
						return true;
					} else {
						return false;
					}

				} //递交事件(form,循环)
			obj.tip_show = function(name, str) {
				$(name).text(str).addClass('active');
			};
			obj.tip_clean = function(name) {
				$(name).removeClass('active');
			};
			obj.tip_setShow = function(name, str, ms) {
				var ms = ms ? ms : 1000;
				obj.tip_show(name, str);
				return setTimeout(function() {
					$(name).removeClass('active');
				}, ms)
			}
		} //$	
})(window.jQuery || window.Zepto)